### Method

# Camel Stream read

#### Declaration [src]

    gssize
    camel_stream_read (
      CamelStream* stream,
      gchar* buffer,
      gsize n,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Attempts to read up to `n` bytes from `stream` into `buffer`.

#### Parameters

`buffer`

  Type: An array of `gchar`

  Output buffer.

  The length of the array is specified in the `n` argument.
  The data is owned by the caller of the method.

`n`

  Type: `gsize`

  Max number of bytes to read.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gssize`

The number of bytes actually read, or -1 on error and set errno.